﻿using Avalonia.Collections;
using Avalonia.Controls;
using AvaloniaApplication2.Models;
using Microsoft.VisualBasic;
using ReactiveUI;
using System.Linq;

namespace AvaloniaApplication2.ViewModels
{
    public class MainWindowViewModel : ViewModelBase
    {
        public static _43pProvalenko2Context myconnection = new _43pProvalenko2Context();

        public static MainWindowViewModel Instance;

        public MainWindowViewModel()
        {
            Instance = this;

            if (AdminExists())
            {
                Page = new AuthAndReg(); // Если администратор есть, открываем страницу Auth
            }
            else
            {
                Page = new AdminReg(); // Если администратора нет, открываем страницу AdminReg
            }
        }
        private UserControl page;

        public UserControl Page { get => page; set => this.RaiseAndSetIfChanged(ref page, value); }

        public void Reg()
        {
            Page = new RegUser();
        }

        public void Auth()
        {
            Page = new Auth();
        }

        private bool AdminExists()
        {
            return myconnection.Users.Any(user => user.Role == 2); 
        }
    }
}
